<?php

/**
 * agrup_concep_tot actions.
 *
 * @package    nomina
 * @subpackage agrup_concep_tot
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class agrup_concep_totActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by ID_TIPO_DOC , NUM_DOC';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $id_periodo = $periodo_filtro;
            $periodo = $request['id_periodo'];
            $id_agrup_concepto = $request['id_agrup_concepto'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //area
            if (isset($request['id_ea'])) {
                $whereArea = " AND tab0.id_ea = " . $request['id_ea'];
            } else {
                $whereArea = ' ';
            }
            //cenop
            if (isset($request['id_cen_op'])) {
                $whereCenOp = " AND tab0.id_cen_op = " . $request['id_cen_op'];
            } else {
                $whereCenOp = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select 
tab0.ID_ESTADO_FUNC,
tab0.ID_TIPO_DOC,
tab0.NUM_DOC,
tab0.ID_DP,
tab0.ID_ANHOS,
tab0.ID_MESES,
tab0.PERIODO,
tab0.ACTUAL,
tab0.ID_EA,
tab0.ID_CEN_OP,
tab0.RN, 
TAB1.DESCRIPCION as DESCRIPCION, TAB1.ABREVIACION as ABREVIACION,
TAB2.PRIMER_NOMBRE as PRIMER_NOMBRE, TAB2.SEGUNDO_NOMBRE as SEGUNDO_NOMBRE, 
TAB2.PRIMER_APELLIDO as PRIMER_APELLIDO, TAB2.SEGUNDO_APELLIDO as SEGUNDO_APELLIDO, 
TAB2.PRIMER_NOMBRE||' '||TAB2.SEGUNDO_NOMBRE as NOMBRE, 
tab2.nombre_apellido,
TAB3.ID_ANHOS||' '||TAB3.ID_MESES as PERIODO_MES,
tab10.fecha_ingreso, tab10.fecha_termina, tab10.fecha_retiro, 
tab5.descripcion as area, 
tab7.nom_cen_op, tab7.prefijo,
TAB8.CODDEPTO as CODDEPTO, TAB9.CODMUN_TEXT as CODMUN_TEXT,
tab4.num_dias

from NO_ESTADO_FUNC_V tab0

join TIPO_DOCUMENTO TAB1 on TAB0.ID_TIPO_DOC = TAB1.ID_TIPO_DOC  
JOIN NO_DATOS_FUNCIONARIO_V tab2 ON tAB0.ID_TIPO_DOC = TAB2.ID_TIPO_DOC and TAB0.NUM_DOC = TAB2.NUM_DOC  
join NO_PERIODO TAB3 on TAB0.PERIODO = TAB3.ID_PERIODO 
left join no_liquida_nomina tab4 on tab0.id_tipo_doc = tab4.id_tipo_dOC and TAB0.NUM_DOC = TAB4.NUM_DOC and TAB0.PERIODO = TAB4.ID_PERIODO  and tab4.id_concep_nomina = 1
left join no_nombramiento_v tab10 ON tab10.id_tipo_doc = tab0.id_tipo_doc and tab10.num_doc = tab0.num_doc 
left join area tab5 on tab0.id_ea = tab5.id_area
left join NO_DP_V TAB6 on tab0.ID_DP = TAB6.ID_DP  
left join CENTRO_OPERACION TAB7 on tab0.ID_CEN_OP = TAB7.ID_CEN_OP  
left join DEPARTAMENTO TAB8 on TAB7.ID_DEPTO = TAB8.ID_DEPTO  
left join MUNICIPIOS TAB9 on TAB7.CODMUN = TAB9.CODMUN 

where 
tab0.periodo = $periodo_filtro 
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereArea $whereCenOp
    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select 
tab0.ID_ESTADO_FUNC,
tab0.ID_TIPO_DOC,
tab0.NUM_DOC,
tab0.ID_DP,
tab0.ID_ANHOS,
tab0.ID_MESES,
tab0.PERIODO,
tab0.ACTUAL,
tab0.ID_EA,
tab0.ID_CEN_OP,
tab0.RN, 
TAB1.DESCRIPCION as DESCRIPCION, TAB1.ABREVIACION as ABREVIACION,
TAB2.PRIMER_NOMBRE as PRIMER_NOMBRE, TAB2.SEGUNDO_NOMBRE as SEGUNDO_NOMBRE, 
TAB2.PRIMER_APELLIDO as PRIMER_APELLIDO, TAB2.SEGUNDO_APELLIDO as SEGUNDO_APELLIDO, 
TAB2.PRIMER_NOMBRE||' '||TAB2.SEGUNDO_NOMBRE as NOMBRE, 
tab2.nombre_apellido,
TAB3.ID_ANHOS||' '||TAB3.ID_MESES as PERIODO_MES,
tab10.fecha_ingreso, tab10.fecha_termina, tab10.fecha_retiro, 
tab5.descripcion as area, 
tab7.nom_cen_op, tab7.prefijo,
TAB8.CODDEPTO as CODDEPTO, TAB9.CODMUN_TEXT as CODMUN_TEXT,
tab4.num_dias

from NO_ESTADO_FUNC_V tab0

join TIPO_DOCUMENTO TAB1 on TAB0.ID_TIPO_DOC = TAB1.ID_TIPO_DOC  
JOIN NO_DATOS_FUNCIONARIO_V tab2 ON tAB0.ID_TIPO_DOC = TAB2.ID_TIPO_DOC and TAB0.NUM_DOC = TAB2.NUM_DOC  
join NO_PERIODO TAB3 on TAB0.PERIODO = TAB3.ID_PERIODO 
left join no_liquida_nomina tab4 on tab0.id_tipo_doc = tab4.id_tipo_dOC and TAB0.NUM_DOC = TAB4.NUM_DOC and TAB0.PERIODO = TAB4.ID_PERIODO  and tab4.id_concep_nomina = 1
left join no_nombramiento_v tab10 ON tab10.id_tipo_doc = tab0.id_tipo_doc and tab10.num_doc = tab0.num_doc 
left join area tab5 on tab0.id_ea = tab5.id_area
left join NO_DP_V TAB6 on tab0.ID_DP = TAB6.ID_DP  
left join CENTRO_OPERACION TAB7 on tab0.ID_CEN_OP = TAB7.ID_CEN_OP  
left join DEPARTAMENTO TAB8 on TAB7.ID_DEPTO = TAB8.ID_DEPTO  
left join MUNICIPIOS TAB9 on TAB7.CODMUN = TAB9.CODMUN 

where 
tab0.periodo = $periodo_filtro 
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereArea $whereCenOp

$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[agrup_concep_tot] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
